1 ifdef CONFIG_GCC_PLUGINS
2 __PLUGINCC := $(call cc-ifversion, -ge, 0408, $(HOSTCXX), $(HOSTCC))
3 PLUGINCC := $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-plugin.sh "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)")
5 SANCOV_PLUGIN := -fplugin=$(objtree)/scripts/gcc-plugins/sancov_plugin.so
7 gcc-plugin-$(CONFIG_GCC_PLUGIN_CYC_COMPLEXITY) += cyc_complexity_plugin.so
9 gcc-plugin-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += latent_entropy_plugin.so
10 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_LATENT_ENTROPY) += -DLATENT_ENTROPY_PLUGIN
11 ifdef CONFIG_GCC_PLUGIN_LATENT_ENTROPY
12 DISABLE_LATENT_ENTROPY_PLUGIN += -fplugin-arg-latent_entropy_plugin-disable
15 ifdef CONFIG_GCC_PLUGIN_SANCOV
16 ifeq ($(CFLAGS_KCOV),)
17 # It is needed because of the gcc-plugin.sh and gcc version checks.
18 gcc-plugin-$(CONFIG_GCC_PLUGIN_SANCOV) += sancov_plugin.so
21 CFLAGS_KCOV := $(SANCOV_PLUGIN)
23 $(warning warning: cannot use CONFIG_KCOV: -fsanitize-coverage=trace-pc is not supported by compiler)
28 gcc-plugin-$(CONFIG_GCC_PLUGIN_STRUCTLEAK) += structleak_plugin.so
29 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK_VERBOSE) += -fplugin-arg-structleak_plugin-verbose
30 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_STRUCTLEAK) += -DSTRUCTLEAK_PLUGIN
32 gcc-plugin-$(CONFIG_GCC_PLUGIN_RANDSTRUCT) += randomize_layout_plugin.so
33 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT) += -DRANDSTRUCT_PLUGIN
34 gcc-plugin-cflags-$(CONFIG_GCC_PLUGIN_RANDSTRUCT_PERFORMANCE) += -fplugin-arg-randomize_layout_plugin-performance-mode
36 GCC_PLUGINS_CFLAGS := $(strip $(addprefix -fplugin=$(objtree)/scripts/gcc-plugins/, $(gcc-plugin-y)) $(gcc-plugin-cflags-y))
38 export PLUGINCC GCC_PLUGINS_CFLAGS GCC_PLUGIN GCC_PLUGIN_SUBDIR
39 export SANCOV_PLUGIN DISABLE_LATENT_ENTROPY_PLUGIN
42 # SANCOV_PLUGIN can be only in CFLAGS_KCOV because avoid duplication.
43 GCC_PLUGINS_CFLAGS := $(filter-out $(SANCOV_PLUGIN), $(GCC_PLUGINS_CFLAGS))
46 KBUILD_CFLAGS += $(GCC_PLUGINS_CFLAGS)
47 GCC_PLUGIN := $(gcc-plugin-y)
48 GCC_PLUGIN_SUBDIR := $(gcc-plugin-subdir-y)
51 # If plugins aren't supported, abort the build before hard-to-read compiler
52 # errors start getting spewed by the main build.
53 PHONY += gcc-plugins-check
54 gcc-plugins-check: FORCE
55 ifdef CONFIG_GCC_PLUGINS
57 ifneq ($(GCC_PLUGINS_CFLAGS),)
58 # Various gccs between 4.5 and 5.1 have bugs on powerpc due to missing
59 # header files. gcc <= 4.6 doesn't work at all, gccs from 4.8 to 5.1 have
60 # issues with 64-bit targets.
61 ifeq ($(ARCH),powerpc)
62 ifeq ($(call cc-ifversion, -le, 0501, y), y)
63 @echo "Cannot use CONFIG_GCC_PLUGINS: plugin support on gcc <= 5.1 is buggy on powerpc, please upgrade to gcc 5.2 or newer" >&2 && exit 1
66 ifeq ($(call cc-ifversion, -ge, 0405, y), y)
67 $(Q)$(srctree)/scripts/gcc-plugin.sh --show-error "$(__PLUGINCC)" "$(HOSTCXX)" "$(CC)" || true
68 @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc installation does not support plugins, perhaps the necessary headers are missing?" >&2 && exit 1
70 @echo "Cannot use CONFIG_GCC_PLUGINS: your gcc version does not support plugins, you should upgrade it to at least gcc 4.5" >&2 && exit 1
77 # Actually do the build, if requested.
79 gcc-plugins: scripts_basic gcc-plugins-check
80 ifdef CONFIG_GCC_PLUGINS
81 $(Q)$(MAKE) $(build)=scripts/gcc-plugins